## libfyaml 0.9

=== CMakeLists.txt ===
if (POLICY CMP0048)
    cmake_policy(SET CMP0048 NEW) # Allow project(xxx VERSION a.b.c)
endif()

# version number below should be the currently under development version,
# so when doing a tag/release it is captured with the proper numbering.
project(fyaml LANGUAGES C VERSION 0.7.2)

cmake_minimum_required(VERSION 3.0)

# Must use GNUInstallDirs to install libraries into correct
# locations on all platforms.
include(GNUInstallDirs)

set(LIBHDRS
  src/lib/fy-accel.h
  src/lib/fy-atom.h
  src/lib/fy-composer.h
  src/lib/fy-diag.h
  src/lib/fy-doc.h
  src/lib/fy-docbuilder.h
  src/lib/fy-docstate.h
  src/lib/fy-dump.h
  src/lib/fy-emit.h src/lib/fy-emit-accum.h
  src/lib/fy-input.h
  src/lib/fy-parse.h
  src/lib/fy-path.h
  src/lib/fy-token.h
  src/lib/fy-types.h
  src/lib/fy-walk.h
  src/util/fy-blob.h
  src/util/fy-ctype.h
  src/util/fy-endian.h
  src/util/fy-id.h
  src/util/fy-list.h
  src/util/fy-typelist.h
  src/util/fy-utf8.h
  src/util/fy-utils.h
  src/xxhash/xxhash.h
)
set(LIBSRCS
  src/lib/fy-accel.c
  src/lib/fy-atom.c
  src/lib/fy-composer.c
  src/lib/fy-diag.c
  src/lib/fy-doc.c
  src/lib/fy-docbuilder.c
  src/lib/fy-docstate.c
  src/lib/fy-dump.c
  src/lib/fy-emit.c
  src/lib/fy-event.c
  src/lib/fy-input.c
  src/lib/fy-parse.c
  src/lib/fy-path.c
  src/lib/fy-token.c
  src/lib/fy-types.c
  src/lib/fy-walk.c
  src/util/fy-blob.c
  src/util/fy-ctype.c
  src/util/fy-utf8.c
  src/util/fy-utils.c
  src/xxhash/xxhash.c
)
set(LIBHDRSPUB
    include/libfyaml.h
)

add_library(${PROJECT_NAME}
    ${LIBHDRS}
    ${LIBSRCS}
    ${LIBHDRSPUB}
)

include(CheckIncludeFile)
check_include_file("byteswap.h" HAVE_BYTESWAP_H)
include(CheckFunctionExists)
check_function_exists(__builtin_bswap16 HAVE___BUILTIN_BSWAP16)
check_function_exists(__builtin_bswap32 HAVE___BUILTIN_BSWAP32)
check_function_exists(__builtin_bswap64 HAVE___BUILTIN_BSWAP64)

add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

set_target_properties(${PROJECT_NAME} PROPERTIES FOLDER "Libraries")

target_include_directories(${PROJECT_NAME}
    PUBLIC
        $<BUILD_INTERFACE:${${PROJECT_NAME}_SOURCE_DIR}/include>
        $<INSTALL_INTERFACE:include>
    PRIVATE
        ${${PROJECT_NAME}_SOURCE_DIR}/src/lib
        ${${PROJECT_NAME}_SOURCE_DIR}/src/util
        ${${PROJECT_NAME}_SOURCE_DIR}/src/xxhash
)

#target_link_libraries(${PROJECT_NAME} PUBLIC xx)
#target_compile_definitions(${PROJECT_NAME} PUBLIC xx)

target_compile_definitions(${PROJECT_NAME} PRIVATE
    VERSION="0.5.7.34"
)

target_compile_definitions(${PROJECT_NAME} PRIVATE
  $<$<NOT:$<CONFIG:DEBUG>>:NDEBUG>
)

# Shared options between GCC and CLANG:
if (NOT MSVC)
	target_compile_options(${PROJECT_NAME} PRIVATE
        -Wall
        -fPIC
        -D_GNU_SOURCE
    )

	if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
		target_compile_options(${PROJECT_NAME} PRIVATE
            -O2
        )
	endif()
endif()

# ==== Install & export target ========

install(TARGETS	${PROJECT_NAME}
		EXPORT 	${PROJECT_NAME}-targets
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)
install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

install(EXPORT ${PROJECT_NAME}-targets
    FILE ${PROJECT_NAME}-targets.cmake
    NAMESPACE ${PROJECT_NAME}::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)
export(
	TARGETS ${PROJECT_NAME}
	FILE "${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}-targets.cmake"
	NAMESPACE ${PROJECT_NAME}::
)


include(CMakePackageConfigHelpers)
configure_package_config_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/cmake/${PROJECT_NAME}-config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}-config.cmake
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)

write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}-config-version.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY AnyNewerVersion
)

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}-config.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/cmake/${PROJECT_NAME}-config-version.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
)

## libfyaml 0.7.12

=== debian/changelog ===
libfyaml (0.7.12-1) unstable; urgency=medium

  * Update VCS URLs to current valid ones.
  * New upstream version 0.7.12

 -- Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>  Tue, 22 Feb 2022 22:25:26 +0100

libfyaml (0.7.11-2) unstable; urgency=medium

  * Source only upload to enable testing migration.
  * Add myself as uploader.

 -- Timo Röhling <roehling@debian.org>  Fri, 18 Feb 2022 14:04:26 +0100

libfyaml (0.7.11-1) unstable; urgency=medium

  * Initial release. (Closes: #998859)
    Thanks to Pantelis Antoniou for his contribution
    to the packaging.

 -- Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>  Fri, 14 Jan 2022 22:51:33 +0100

=== debian/control ===
Source: libfyaml
Priority: optional
Maintainer: Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>
Uploaders: Timo Röhling <roehling@debian.org>
Build-Depends: debhelper-compat (= 13),
               pkg-config,
               libltdl-dev
Standards-Version: 4.6.0
Section: libs
Homepage: https://github.com/pantoniou/libfyaml
Vcs-Git: https://salsa.debian.org/jlblancoc/libfyaml-gbp.git
Vcs-Browser: https://salsa.debian.org/jlblancoc/libfyaml-gbp

Package: libfyaml-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libfyaml0 (= ${binary:Version})
Description: Fully feature complete YAML parser and emitter (headers)
 Fully feature complete YAML parser and emitter, supporting the latest YAML
 spec and passing the full YAML testsuite.
 .
 It is designed to be very efficient, avoiding copies of data, and has no
 artificial limits like the 1024 character limit for implicit keys.
 .
 This package contains development headers and static libraries.

Package: libfyaml-utils
Section: devel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libfyaml0 (= ${binary:Version})
Description: Fully feature complete YAML parser and emitter (CLI tools)
 Fully feature complete YAML parser and emitter, supporting the latest YAML
 spec and passing the full YAML testsuite.
 .
 It is designed to be very efficient, avoiding copies of data, and has no
 artificial limits like the 1024 character limit for implicit keys.
 .
 This package contains utilities manipulating YAML files.

Package: libfyaml0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: Fully feature complete YAML parser and emitter (library)
 Fully feature complete YAML parser and emitter, supporting the latest YAML
 spec and passing the full YAML testsuite.
 .
 It is designed to be very efficient, avoiding copies of data, and has no
 artificial limits like the 1024 character limit for implicit keys.

=== debian/rules ===
#!/usr/bin/make -f

# debian builds do not like testsuites to download stuff
%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --disable-network

=== debian/watch ===
version=4
https://github.com/pantoniou/libfyaml/releases .*/libfyaml-(\d\S*)\.tar\.gz

## libfyaml 0.8

=== debian/changelog ===
libfyaml (0.8-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 11:45:01 +0200

libfyaml (0.8-1) unstable; urgency=medium

  * New upstream version 0.8
  * Add .symbols for public API
  * Add hardening flags to build

 -- Timo Röhling <roehling@debian.org>  Sun, 18 Jun 2023 22:40:15 +0200

libfyaml (0.7.12-2) unstable; urgency=medium

  * Fix d/watch
  * Bump Standards-Version to 4.6.2

 -- Timo Röhling <roehling@debian.org>  Fri, 23 Dec 2022 14:16:49 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: libfyaml
 Priority: optional
-Maintainer: Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>
 Uploaders: Timo Röhling <roehling@debian.org>
 Build-Depends: debhelper-compat (= 13),
                pkg-config,
                libltdl-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Section: libs
 Homepage: https://github.com/pantoniou/libfyaml
 Vcs-Git: https://salsa.debian.org/jlblancoc/libfyaml-gbp.git

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 # debian builds do not like testsuites to download stuff
 %:

## libfyaml 0.9

=== debian/changelog ===
libfyaml (0.9-2) unstable; urgency=medium

  * Link against libatomic where needed
  * Disable build log prettifier (shave)
  * Hide symbols less agressively (causes segfault on mips64el)

 -- Timo Röhling <roehling@debian.org>  Wed, 24 Sep 2025 11:46:02 +0200

libfyaml (0.9-1) unstable; urgency=medium

  * Migrate debian/watch to version 5 format
  * New upstream version 0.9 (Closes: #1107090, #1115982)
  * Wrap and sort Debian package files
  * Bump Standards-Version to 4.7.2
  * Keep exported ABI clean
  * Depend on pkgconf instead of pkg-config
  * Update d/copyright

 -- Timo Röhling <roehling@debian.org>  Mon, 22 Sep 2025 21:33:49 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: libfyaml
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>
-Uploaders: Timo Röhling <roehling@debian.org>
-Build-Depends: debhelper-compat (= 13),
-               pkg-config,
-               libltdl-dev
-Standards-Version: 4.6.2
+Maintainer: Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>
+Uploaders:
+ Timo Röhling <roehling@debian.org>,
+Build-Depends:
+ debhelper-compat (= 13),
+ libltdl-dev,
+ pkgconf,
+Standards-Version: 4.7.2
 Section: libs
 Homepage: https://github.com/pantoniou/libfyaml
 Vcs-Git: https://salsa.debian.org/jlblancoc/libfyaml-gbp.git
@@ -16,7 +17,9 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, libfyaml0 (= ${binary:Version})
+Depends:
+ libfyaml0 (= ${binary:Version}),
+ ${misc:Depends},
 Description: Fully feature complete YAML parser and emitter (headers)
  Fully feature complete YAML parser and emitter, supporting the latest YAML
  spec and passing the full YAML testsuite.
@@ -29,7 +32,10 @@
 Package: libfyaml-utils
 Section: devel
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, libfyaml0 (= ${binary:Version})
+Depends:
+ libfyaml0 (= ${binary:Version}),
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: Fully feature complete YAML parser and emitter (CLI tools)
  Fully feature complete YAML parser and emitter, supporting the latest YAML
  spec and passing the full YAML testsuite.
@@ -42,7 +48,9 @@
 Package: libfyaml0
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${shlibs:Depends}, ${misc:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: Fully feature complete YAML parser and emitter (library)
  Fully feature complete YAML parser and emitter, supporting the latest YAML
  spec and passing the full YAML testsuite.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--version-script=$(CURDIR)/debian/libfyaml0.map
ifneq ($(filter armel m68k powerpc sh4,$(DEB_HOST_ARCH)),)
DEB_LDFLAGS_MAINT_APPEND += -latomic
endif

# debian builds do not like testsuites to download stuff
%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --disable-network --disable-shave

=== debian/watch ===
Version: 5

Template: Github
Owner: pantoniou
Project: libfyaml

## libfyaml 0.9.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

if (POLICY CMP0048)
    cmake_policy(SET CMP0048 NEW) # Allow project(xxx VERSION a.b.c)
endif()

if (POLICY CMP0074)
    cmake_policy(SET CMP0074 NEW) # find_package uses <PackageName>_ROOT variables
endif()

if (POLICY CMP0110)
    cmake_policy(SET CMP0110 NEW) # add_test() supports arbitrary characters in test names
endif()

# Get version from git-version-gen
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.tarball-version")
    file(READ "${CMAKE_CURRENT_SOURCE_DIR}/.tarball-version" PROJECT_VERSION)
    string(STRIP "${PROJECT_VERSION}" PROJECT_VERSION)
else()
    execute_process(
        COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/build-aux/git-version-gen" "${CMAKE_CURRENT_SOURCE_DIR}/.tarball-version"
        OUTPUT_VARIABLE PROJECT_VERSION
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
endif()

# Parse version components
string(REGEX MATCH "^([0-9]+)(\\.([0-9]+)(\\.([0-9]+))?)?(-(.*))?$" _ "${PROJECT_VERSION}")
set(VERSION_MAJOR "${CMAKE_MATCH_1}")
if(CMAKE_MATCH_3)
    set(VERSION_MINOR "${CMAKE_MATCH_3}")
else()
    set(VERSION_MINOR "0")
endif()
if(CMAKE_MATCH_5)
    set(VERSION_PATCH "${CMAKE_MATCH_5}")
else()
    set(VERSION_PATCH "0")
endif()
if(CMAKE_MATCH_7)
    set(VERSION_EXTRA "${CMAKE_MATCH_7}")
else()
    set(VERSION_EXTRA "")
endif()

project(libfyaml LANGUAGES C ASM VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})

# Must use GNUInstallDirs to install libraries into correct locations on all platforms
include(GNUInstallDirs)
include(CheckIncludeFile)
include(CheckFunctionExists)
include(CheckCSourceCompiles)
include(CheckCCompilerFlag)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(CMakeDependentOption)
include(CTest)
include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/CheckLibClang.cmake)

# does this CMake version understand generator expressions?
if(${CMAKE_VERSION} VERSION_LESS "3.27")
    set(HAVE_CMAKE_GEXPR 0)
else()
    set(HAVE_CMAKE_GEXPR 1)
endif()

# Macro to add libclang support to a target
macro(add_libclang_to_target target_name link_scope)
    if(HAVE_LIBCLANG)
        # Split LIBCLANG_CFLAGS into list and add as compile options
        string(REPLACE " " ";" LIBCLANG_CFLAGS_LIST "${LIBCLANG_CFLAGS}")
        target_compile_options(${target_name} PRIVATE ${LIBCLANG_CFLAGS_LIST})

        # Split LIBCLANG_LDFLAGS into list and add as link directories/options
        # LIBCLANG_LDFLAGS typically contains -L/path/to/lib and -Wl,flags
        # Extract only the -L paths
        string(REGEX MATCHALL "-L([^ ]+)" LIBCLANG_L_FLAGS "${LIBCLANG_LDFLAGS}")
        set(LIBCLANG_LINK_DIRS_LOCAL "")
        foreach(flag ${LIBCLANG_L_FLAGS})
            string(REGEX REPLACE "^-L" "" dir "${flag}")
            list(APPEND LIBCLANG_LINK_DIRS_LOCAL "${dir}")
        endforeach()
        if(LIBCLANG_LINK_DIRS_LOCAL)
            target_link_directories(${target_name} ${link_scope} ${LIBCLANG_LINK_DIRS_LOCAL})
        endif()

        # Add libclang libraries
	target_link_libraries(${target_name} ${link_scope} ${LIBCLANG_LIBS})
    endif()
endmacro()

# Options
option(BUILD_SHARED_LIBS "Build shared libraries" ON)
option(ENABLE_PORTABLE_TARGET "Enable portable mode (disable per-target optimizations)" OFF)
option(ENABLE_STATIC_TOOLS "Tools will be compiled as static executables" OFF)
option(ENABLE_ASAN "Enable ASAN support" OFF)
option(ENABLE_NETWORK "Enable tests requiring network access" ON)
option(ENABLE_DEVMODE "Enable development mode only debugging" OFF)
option(BUILD_TESTING "Build tests" ON)
option(ENABLE_LIBCLANG "Enable libclang support for reflection" ON)

# Path to LLVM installation (optional, overrides automatic detection)
set(LLVM_ROOT "" CACHE PATH "Path to LLVM installation directory (e.g., /usr/lib/llvm-15)")

# Read libtool version
file(READ "${CMAKE_CURRENT_SOURCE_DIR}/.libtool-version" LIBTOOL_VERSION)
string(STRIP "${LIBTOOL_VERSION}" LIBTOOL_VERSION)

# Parse libtool version components (format is current:revision:age)
string(REGEX REPLACE "^([0-9]+):.*" "\\1" LIBTOOL_CURRENT "${LIBTOOL_VERSION}")
string(REGEX REPLACE "^[0-9]+:([0-9]+):.*" "\\1" LIBTOOL_REVISION "${LIBTOOL_VERSION}")
string(REGEX REPLACE "^[0-9]+:[0-9]+:([0-9]+)" "\\1" LIBTOOL_AGE "${LIBTOOL_VERSION}")

# Calculate SO version (current - age)
math(EXPR SO_VERSION "${LIBTOOL_CURRENT} - ${LIBTOOL_AGE}")
set(SO_VERSION_FULL "${SO_VERSION}.${LIBTOOL_AGE}.${LIBTOOL_REVISION}")

# Platform detection
if(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64|AMD64")
    set(TARGET_CPU_X86_64 TRUE)
    set(TARGET_CPU_ANY_X86 TRUE)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "i.86|x86")
    set(TARGET_CPU_X86 TRUE)
    set(TARGET_CPU_ANY_X86 TRUE)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "aarch64|arm64")
    set(TARGET_CPU_ARM64 TRUE)
    set(TARGET_CPU_ANY_ARM TRUE)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "arm")
    set(TARGET_CPU_ARM TRUE)
    set(TARGET_CPU_ANY_ARM TRUE)
endif()

if(CMAKE_CROSSCOMPILING)
    set(CROSS_COMPILING 1)
    message(STATUS "Cross-compiling detected:")
    message(STATUS "  Build system: ${CMAKE_HOST_SYSTEM_NAME} ${CMAKE_HOST_SYSTEM_PROCESSOR}")
    message(STATUS "  Target system: ${CMAKE_SYSTEM_NAME} ${CMAKE_SYSTEM_PROCESSOR}")
else()
    set(CROSS_COMPILING 0)
endif()

# Check for required dependencies
set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
set(THREADS_PREFER_PTHREAD_FLAG TRUE)
find_package(Threads REQUIRED)
if(NOT CMAKE_USE_PTHREADS_INIT)
    message(FATAL_ERROR "Missing required pthread support")
endif()

# Check for headers and functions
check_include_file("byteswap.h" HAVE_BYTESWAP_H)
check_function_exists(__builtin_bswap16 HAVE___BUILTIN_BSWAP16)
check_function_exists(__builtin_bswap32 HAVE___BUILTIN_BSWAP32)
check_function_exists(__builtin_bswap64 HAVE___BUILTIN_BSWAP64)
check_function_exists(qsort_r HAVE_QSORT_R)
check_function_exists(mremap HAVE_MREMAP)

# Check for environment variables
check_c_source_compiles("
    extern char **environ;
    int main() { return 0; }
" HAVE_DECL_ENVIRON)

# Check for optional dependencies

# libyaml detection - try CMake config first, then pkg-config
set(HAVE_LIBYAML 0)
find_package(yaml QUIET CONFIG)
if(yaml_FOUND)
    set(HAVE_LIBYAML 1)
    # CMake config found, use imported target
    set(LIBYAML_LIBRARIES yaml)
    message(STATUS "Found libyaml via CMake config")
else()
    find_package(PkgConfig)
    if(PKG_CONFIG_FOUND)
        pkg_check_modules(LIBYAML yaml-0.1)
        if(LIBYAML_FOUND)
            set(HAVE_LIBYAML 1)
            message(STATUS "Found libyaml via pkg-config")
        else()
            message(WARNING "failed to find libyaml; compatibility disabled")
        endif()
    endif()
endif()

# check framework detection - try CMake config first, then pkg-config
set(HAVE_CHECK 0)
set(HAVE_COMPATIBLE_CHECK 0)
if(BUILD_TESTING)
    find_package(check QUIET CONFIG)
    if(check_FOUND)
        set(HAVE_CHECK 1)
        set(CHECK_LIBRARIES check)
        get_target_property(CHECK_INCLUDE_DIRS check INTERFACE_INCLUDE_DIRECTORIES)
        # Get library location to extract directory
        get_target_property(CHECK_LIB_LOCATION check IMPORTED_LOCATION)
        if(NOT CHECK_LIB_LOCATION)
            get_target_property(CHECK_LIB_LOCATION check LOCATION)
        endif()
        if(CHECK_LIB_LOCATION)
            get_filename_component(CHECK_LIBRARY_DIRS "${CHECK_LIB_LOCATION}" DIRECTORY)
        endif()
        message(STATUS "Found check framework via CMake config")

        # Check if libcheck has srunner_set_tap (jessie has outdated libcheck)
        set(_TEMP_CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES}")
        set(_TEMP_CMAKE_REQUIRED_INCLUDES  "${CMAKE_REQUIRED_INCLUDES}")
        # For CMake config targets, use the target directly
        set(CMAKE_REQUIRED_LIBRARIES check)
        set(CMAKE_REQUIRED_INCLUDES ${CHECK_INCLUDE_DIRS})

        check_symbol_exists(srunner_set_tap "check.h" HAVE_SRUNNER_SET_TAP)

        set(CMAKE_REQUIRED_LIBRARIES "${_TEMP_CMAKE_REQUIRED_LIBRARIES}")
        set(CMAKE_REQUIRED_INCLUDES  "${_TEMP_CMAKE_REQUIRED_INCLUDES}")
        unset(_TEMP_CMAKE_REQUIRED_LIBRARIES)
        unset(_TEMP_CMAKE_REQUIRED_INCLUDES)

        if(HAVE_SRUNNER_SET_TAP)
            set(HAVE_COMPATIBLE_CHECK 1)
        endif()
    else()
        # Fall back to pkg-config
        find_package(PkgConfig)
        if(PKG_CONFIG_FOUND)
            pkg_check_modules(CHECK check)
            if(CHECK_FOUND)
                set(HAVE_CHECK 1)
                message(STATUS "Found check framework via pkg-config")

                # Check if libcheck has srunner_set_tap (jessie has outdated libcheck)
                set(_TEMP_CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES}")
                set(_TEMP_CMAKE_REQUIRED_INCLUDES  "${CMAKE_REQUIRED_INCLUDES}")
                set(_TEMP_CMAKE_REQUIRED_LINK_OPTIONS "${CMAKE_REQUIRED_LINK_OPTIONS}")
                set(CMAKE_REQUIRED_LIBRARIES ${CHECK_LIBRARIES})
                set(CMAKE_REQUIRED_INCLUDES ${CHECK_INCLUDE_DIRS})
                # Add library directories to linker flags
                foreach(libdir ${CHECK_LIBRARY_DIRS})
                    list(APPEND CMAKE_REQUIRED_LINK_OPTIONS "-L${libdir}")
                endforeach()

                check_symbol_exists(srunner_set_tap "check.h" HAVE_SRUNNER_SET_TAP)

                set(CMAKE_REQUIRED_LIBRARIES "${_TEMP_CMAKE_REQUIRED_LIBRARIES}")
                set(CMAKE_REQUIRED_INCLUDES  "${_TEMP_CMAKE_REQUIRED_INCLUDES}")
                set(CMAKE_REQUIRED_LINK_OPTIONS "${_TEMP_CMAKE_REQUIRED_LINK_OPTIONS}")
                unset(_TEMP_CMAKE_REQUIRED_LIBRARIES)
                unset(_TEMP_CMAKE_REQUIRED_INCLUDES)
                unset(_TEMP_CMAKE_REQUIRED_LINK_OPTIONS)

                if(HAVE_SRUNNER_SET_TAP)
                    set(HAVE_COMPATIBLE_CHECK 1)
                endif()
            endif()
        endif()
    endif()
endif()

# Check for libclang (for reflection support)
set(HAVE_LIBCLANG 0)
set(LIBCLANG_CFLAGS "")
set(LIBCLANG_LDFLAGS "")
set(LIBCLANG_LIBS "")
set(LIBCLANG_FOUND FALSE)
set(LIBCLANG_DETECTION_METHOD "")

if(NOT HAVE_CMAKE_GEXPR)
    message(STATUS "libclang support disabled (CMake version is too old (<=3.27)")
    set(ENABLE_LIBCLANG OFF CACHE BOOL "Disable my feature" FORCE)
endif()

if(NOT ENABLE_LIBCLANG)
    message(STATUS "libclang support disabled (ENABLE_LIBCLANG=OFF)")
else()

    # If user specified LLVM_ROOT, add it to CMAKE_PREFIX_PATH for this search
    if(LLVM_ROOT)
        message(STATUS "Using user-specified LLVM_ROOT: ${LLVM_ROOT}")
        list(PREPEND CMAKE_PREFIX_PATH "${LLVM_ROOT}")
    endif()

    # Try CMake config mode first
    find_package(LLVM QUIET CONFIG)

    # If LLVM was found, help CMake find Clang in the same installation
    if(LLVM_FOUND)
        # Clang's config is typically in ${LLVM_INSTALL_PREFIX}/lib/cmake/clang
        set(Clang_DIR "${LLVM_INSTALL_PREFIX}/lib/cmake/clang")
    endif()

    find_package(Clang QUIET CONFIG)

    if(LLVM_FOUND AND Clang_FOUND)

        message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION} via CMake config")
        message(STATUS "  LLVM_INSTALL_PREFIX: ${LLVM_INSTALL_PREFIX}")
        message(STATUS "  LLVM_INCLUDE_DIRS: ${LLVM_INCLUDE_DIRS}")

        # Use LLVM's CMake variables directly
        set(LIBCLANG_CFLAGS_LIST ${LLVM_DEFINITIONS})
        list(APPEND LIBCLANG_CFLAGS_LIST "-I${LLVM_INCLUDE_DIRS}")
        list(APPEND LIBCLANG_CFLAGS_LIST "-I${CLANG_INCLUDE_DIRS}")

        # Set up library directories
        set(LIBCLANG_LINK_DIRS ${LLVM_LIBRARY_DIRS})

        # Link against libclang (C API) and LLVM core libs
        # Need to link against LLVM core for LLVMShutdown() and other LLVM APIs
        if(TARGET libclang)
            set(LIBCLANG_LIBS_LIST libclang LLVM)
        else()
            set(LIBCLANG_LIBS_LIST clang LLVM)
        endif()

        set(LIBCLANG_INCLUDES "${LLVM_INCLUDE_DIRS};${CLANG_INCLUDE_DIRS}")
        set(LIBCLANG_FOUND TRUE)
        set(LIBCLANG_DETECTION_METHOD "CMake config")
    elseif(NOT CROSS_COMPILING)

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(libfyaml-examples C)

# Find libfyaml
find_package(libfyaml 0.9 QUIET)

if(NOT libfyaml_FOUND)
    # Fall back to pkg-config
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(LIBFYAML REQUIRED libfyaml)

    # Create imported target for consistency
    add_library(libfyaml::libfyaml INTERFACE IMPORTED)
    set_target_properties(libfyaml::libfyaml PROPERTIES
        INTERFACE_INCLUDE_DIRECTORIES "${LIBFYAML_INCLUDE_DIRS}"
        INTERFACE_LINK_LIBRARIES "${LIBFYAML_LIBRARIES}"
        INTERFACE_LINK_DIRECTORIES "${LIBFYAML_LIBRARY_DIRS}"
        INTERFACE_COMPILE_OPTIONS "${LIBFYAML_CFLAGS_OTHER}"
    )
endif()

# List of all examples
set(EXAMPLES
    quick-start
    basic-parsing
    path-queries
    document-manipulation
    event-streaming
    build-from-scratch
)

# Build each example
foreach(example ${EXAMPLES})
    add_executable(${example} ${example}.c)
    target_link_libraries(${example} PRIVATE libfyaml::libfyaml)

    # Set C standard
    set_property(TARGET ${example} PROPERTY C_STANDARD 99)

    # Enable warnings
    if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang")
        target_compile_options(${example} PRIVATE -Wall -Wextra)
    endif()
endforeach()

# Installation (optional)
install(TARGETS ${EXAMPLES}
    RUNTIME DESTINATION bin/libfyaml-examples
)

# Install sample files
install(FILES
    README.md
    config.yaml
    invoice.yaml
    DESTINATION share/doc/libfyaml/examples
)

# Show configuration info
message(STATUS "libfyaml examples configuration:")
message(STATUS "  Examples to build: ${EXAMPLES}")
if(libfyaml_FOUND)
    message(STATUS "  Found libfyaml via CMake config")
    if(libfyaml_HAS_LIBCLANG)
        message(STATUS "  libfyaml has reflection support")
    endif()
else()
    message(STATUS "  Found libfyaml via pkg-config")
endif()

=== debian/changelog ===
libfyaml (0.9.2-1) unstable; urgency=medium

  * New upstream version 0.9.2
  * Bump Standards-Version to 4.7.3
  * Update .symbols file
  * Update d/copyright to reflect licensing change

 -- Timo Röhling <roehling@debian.org>  Fri, 02 Jan 2026 23:50:58 +0100

## libfyaml 0.9.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -148,6 +148,7 @@
 endif()
 
 # Check for headers and functions
+check_include_file("alloca.h" HAVE_ALLOCA_H)
 check_include_file("byteswap.h" HAVE_BYTESWAP_H)
 check_function_exists(__builtin_bswap16 HAVE___BUILTIN_BSWAP16)
 check_function_exists(__builtin_bswap32 HAVE___BUILTIN_BSWAP32)
@@ -316,4 +317,3 @@
         set(LIBCLANG_INCLUDES "${LLVM_INCLUDE_DIRS};${CLANG_INCLUDE_DIRS}")
         set(LIBCLANG_FOUND TRUE)
         set(LIBCLANG_DETECTION_METHOD "CMake config")
-    elseif(NOT CROSS_COMPILING)

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,4 @@
+set(CMAKE_PREFIX_PATH "/home/panto/work/libfyaml/build")
 cmake_minimum_required(VERSION 3.12)
 project(libfyaml-examples C)

=== debian/changelog ===
libfyaml (0.9.3-1) unstable; urgency=medium

  * New upstream version 0.9.3
    - Fix abort in in AppStream:as-test_yaml (Closes: #1126193)

 -- Timo Röhling <roehling@debian.org>  Tue, 27 Jan 2026 11:46:11 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  debhelper-compat (= 13),
  libltdl-dev,
  pkgconf,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Section: libs
 Homepage: https://github.com/pantoniou/libfyaml
 Vcs-Git: https://salsa.debian.org/jlblancoc/libfyaml-gbp.git

## libfyaml 0.9.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.10)
+cmake_minimum_required(VERSION 3.14)
 
 if (POLICY CMP0048)
     cmake_policy(SET CMP0048 NEW) # Allow project(xxx VERSION a.b.c)
@@ -42,6 +42,10 @@
 else()
     set(VERSION_EXTRA "")
 endif()
+
+# Optional MSVC cross-compilation support via msvc-wine
+# Usage: cmake -DMSVC_WINE_DIR=/path/to/msvc [-DMSVC_WINE_COMPILER=cl|clang-cl|clang] ..
+include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/MSVCCrossCompile.cmake OPTIONAL)
 
 project(libfyaml LANGUAGES C ASM VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
 
@@ -85,7 +89,7 @@
         endif()
 
         # Add libclang libraries
-	target_link_libraries(${target_name} ${link_scope} ${LIBCLANG_LIBS})
+        target_link_libraries(${target_name} ${link_scope} ${LIBCLANG_LIBS})
     endif()
 endmacro()
 
@@ -97,7 +101,7 @@
 option(ENABLE_NETWORK "Enable tests requiring network access" ON)
 option(ENABLE_DEVMODE "Enable development mode only debugging" OFF)
 option(BUILD_TESTING "Build tests" ON)
-option(ENABLE_LIBCLANG "Enable libclang support for reflection" ON)
+option(ENABLE_LIBCLANG "Enable libclang support for reflection" OFF)
 
 # Path to LLVM installation (optional, overrides automatic detection)
 set(LLVM_ROOT "" CACHE PATH "Path to LLVM installation directory (e.g., /usr/lib/llvm-15)")
@@ -140,11 +144,21 @@
 endif()
 
 # Check for required dependencies
-set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
-set(THREADS_PREFER_PTHREAD_FLAG TRUE)
-find_package(Threads REQUIRED)
-if(NOT CMAKE_USE_PTHREADS_INIT)
-    message(FATAL_ERROR "Missing required pthread support")
+if(NOT WIN32)
+    set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
+    set(THREADS_PREFER_PTHREAD_FLAG TRUE)
+    find_package(Threads REQUIRED)
+    if(NOT CMAKE_USE_PTHREADS_INIT)
+        message(FATAL_ERROR "Missing required pthread support")
+    endif()
+else()
+    # Windows uses native threading APIs
+    set(CMAKE_USE_WIN32_THREADS_INIT TRUE)
+endif()
+
+# detect if we're on clang-cl
+if(WIN32 AND MSVC AND CMAKE_C_COMPILER_ID STREQUAL "Clang")
+    set(CLANG_CL TRUE)
 endif()
 
 # Check for headers and functions
@@ -162,6 +176,11 @@
     int main() { return 0; }
 " HAVE_DECL_ENVIRON)
 
+# find PkgConfig
+if(NOT CMAKE_CROSSCOMPILING)
+    find_package(PkgConfig)
+endif()
+
 # Check for optional dependencies
 
 # libyaml detection - try CMake config first, then pkg-config
@@ -173,7 +192,6 @@
     set(LIBYAML_LIBRARIES yaml)
     message(STATUS "Found libyaml via CMake config")
 else()
-    find_package(PkgConfig)
     if(PKG_CONFIG_FOUND)
         pkg_check_modules(LIBYAML yaml-0.1)
         if(LIBYAML_FOUND)
@@ -185,10 +203,10 @@
     endif()
 endif()
 
-# check framework detection - try CMake config first, then pkg-config
+# check framework detection - try CMake config first, then pkg-config, then FetchContent
 set(HAVE_CHECK 0)
 set(HAVE_COMPATIBLE_CHECK 0)
-if(BUILD_TESTING)
+if(BUILD_TESTING AND NOT CMAKE_CROSSCOMPILING)
     find_package(check QUIET CONFIG)
     if(check_FOUND)
         set(HAVE_CHECK 1)
@@ -223,7 +241,6 @@
         endif()
     else()
         # Fall back to pkg-config
-        find_package(PkgConfig)
         if(PKG_CONFIG_FOUND)
             pkg_check_modules(CHECK check)
             if(CHECK_FOUND)
@@ -256,6 +273,28 @@
             endif()
         endif()
     endif()
+
+    # Fall back to FetchContent if check not found (useful on Windows)
+    if(NOT HAVE_CHECK)
+        include(FetchContent)
+        message(STATUS "check framework not found, fetching via FetchContent...")
+        FetchContent_Declare(
+            check
+            GIT_REPOSITORY https://github.com/libcheck/check.git
+            GIT_TAG        0.15.2
+        )
+        # Disable check's own tests and docs
+        set(CHECK_ENABLE_TESTS OFF CACHE BOOL "" FORCE)
+        set(CHECK_ENABLE_GCOV OFF CACHE BOOL "" FORCE)
+        FetchContent_MakeAvailable(check)
+
+        set(HAVE_CHECK 1)
+        set(CHECK_LIBRARIES check)
+        set(CHECK_INCLUDE_DIRS "${check_SOURCE_DIR}/src" "${check_BINARY_DIR}" "${check_BINARY_DIR}/src")
+        set(HAVE_SRUNNER_SET_TAP 1)  # 0.15.2 has srunner_set_tap
+        set(HAVE_COMPATIBLE_CHECK 1)
+        message(STATUS "Found check framework via FetchContent")
+    endif()
 endif()
 
 # Check for libclang (for reflection support)
@@ -277,43 +316,3 @@
 
     # If user specified LLVM_ROOT, add it to CMAKE_PREFIX_PATH for this search
     if(LLVM_ROOT)
-        message(STATUS "Using user-specified LLVM_ROOT: ${LLVM_ROOT}")
-        list(PREPEND CMAKE_PREFIX_PATH "${LLVM_ROOT}")
-    endif()
-
-    # Try CMake config mode first
-    find_package(LLVM QUIET CONFIG)
-
-    # If LLVM was found, help CMake find Clang in the same installation
-    if(LLVM_FOUND)
-        # Clang's config is typically in ${LLVM_INSTALL_PREFIX}/lib/cmake/clang
-        set(Clang_DIR "${LLVM_INSTALL_PREFIX}/lib/cmake/clang")
-    endif()
-
-    find_package(Clang QUIET CONFIG)
-
-    if(LLVM_FOUND AND Clang_FOUND)
-
-        message(STATUS "Found LLVM ${LLVM_PACKAGE_VERSION} via CMake config")
-        message(STATUS "  LLVM_INSTALL_PREFIX: ${LLVM_INSTALL_PREFIX}")
-        message(STATUS "  LLVM_INCLUDE_DIRS: ${LLVM_INCLUDE_DIRS}")
-
-        # Use LLVM's CMake variables directly
-        set(LIBCLANG_CFLAGS_LIST ${LLVM_DEFINITIONS})
-        list(APPEND LIBCLANG_CFLAGS_LIST "-I${LLVM_INCLUDE_DIRS}")
-        list(APPEND LIBCLANG_CFLAGS_LIST "-I${CLANG_INCLUDE_DIRS}")
-
-        # Set up library directories
-        set(LIBCLANG_LINK_DIRS ${LLVM_LIBRARY_DIRS})
-
-        # Link against libclang (C API) and LLVM core libs
-        # Need to link against LLVM core for LLVMShutdown() and other LLVM APIs
-        if(TARGET libclang)
-            set(LIBCLANG_LIBS_LIST libclang LLVM)
-        else()
-            set(LIBCLANG_LIBS_LIST clang LLVM)
-        endif()
-
-        set(LIBCLANG_INCLUDES "${LLVM_INCLUDE_DIRS};${CLANG_INCLUDE_DIRS}")
-        set(LIBCLANG_FOUND TRUE)
-        set(LIBCLANG_DETECTION_METHOD "CMake config")

=== debian/changelog ===
libfyaml (0.9.4-1) unstable; urgency=medium

  * New upstream version 0.9.4
  * Update libfyaml0.symbols

 -- Timo Röhling <roehling@debian.org>  Thu, 12 Feb 2026 18:19:17 +0100
